// WuBiLianXi.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "WuBiLianXi.h"
#include "resource.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text
HFONT charFont; // default font
HFONT wlcmFont; // welcome font
HFONT winFont; // windows font
HFONT exerFont; // exercise dialog font
TCHAR szChar[3] = _T("");
std::list<WUBIITEM> itemList;
std::list<WUBIITEM>::iterator itemListI;

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK Exercise(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;
	
	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_WUBILIANXI, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	
	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}
	
	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_WUBILIANXI);
	
	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	
	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;
	
	wcex.cbSize = sizeof(WNDCLASSEX); 
	
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_WUBILIANXI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_WUBILIANXI;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);
	
	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
	HWND hWnd;
	
	hInst = hInstance; // Store instance handle in our global variable
	
	hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);
	
	if (!hWnd)
	{
		return FALSE;
	}
	
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	
	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	// Pre-defined
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR szHello[2048];
	LoadString(hInst, IDS_HELLO, szHello, sizeof(szHello));
	
	switch (message) 
	{
	case WM_CREATE:
		{
			// hwndEdit - the edit window
			// charFont - character font
			// wlcmFont - welcome font
			// winFont - windows font
			HDC hDC;
			itemListI = itemList.end();
			hDC = GetDC(hWnd);
			charFont = CreateCharacterFont(hDC);
			exerFont = CreateExerciseFont(hDC);
			wlcmFont = CreateWelcomeFont(hDC);
			if (charFont != NULL && exerFont != NULL
				&& wlcmFont != NULL)
			{
				winFont = GetOldFont(hDC, charFont);
				ReleaseDC(hWnd, hDC);
			}
			else
			{
				ReleaseDC(hWnd, hDC);
				MessageBox(hWnd, "ʧ", "", MB_OK | MB_ICONSTOP);
				DestroyWindow(hWnd);
			}
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam); 
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_EXER_OPEN:
			LoadExerciseFile(hWnd);
			break;
		case IDM_EXER_STRT:
			DialogBox(hInst, (LPCTSTR)IDD_EXERCISE, hWnd, (DLGPROC)Exercise);
			break;
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		{
			HFONT o;
			RECT rt;
			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rt);
			o = (HFONT)SelectObject(hdc, wlcmFont);
			DrawText(hdc, szHello, _tcslen(szHello), &rt, DT_CENTER);
			SelectObject(hdc, o);
			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		if (charFont != NULL)
		{
			DeleteObject(charFont);
		}
		if (exerFont != NULL)
		{
			DeleteObject(exerFont);
		}
		if (wlcmFont != NULL)
		{
			DeleteObject(wlcmFont);
		}
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for the Exercise dialog
LRESULT CALLBACK Exercise(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	// User-defined
	static HWND hwndEdit; // the edit window
	static int netm = 0; // number of error times
	// static HWND hwndBtn; // the button

	switch (message)
	{
	case WM_INITDIALOG:
		{
			HDC hDC;
			int y; // y start
			// Get the old font
			hDC = GetDC(hDlg);
			y = 0;
			PreserveCharacterSpace(hDC, charFont, &y);
			hwndEdit = CreateEditControl(hDlg, hDC, exerFont, &y);
			//hwndBtn = CreateButtonControl(hDlg, hDC, &y);
			ReleaseDC(hDlg, hDC);
			if ((HWND)wParam != hwndEdit)
			{
				SetFocus(hwndEdit);
				return FALSE;
			}
		}
		return TRUE;
	case WM_PAINT:
		{
			HDC hDC;
			PAINTSTRUCT ps;
			HFONT o;
			hDC = BeginPaint(hDlg, &ps);
			o = (HFONT)SelectObject(hDC, charFont);
			if (itemListI != itemList.end())
			{
				TextOut(hDC, PointToPixel(hDC, 6), 0, itemListI->c, 2);
			}
			SelectObject(hDC, o);
			EndPaint(hDlg, &ps);
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDCANCEL:
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		case IDOK:
			ConfirmAnswer(hDlg, &netm);
			break;
		case IDC_PREV:
			GoPrevChar(hDlg, &netm);
			break;
		case IDC_NEXT:
			GoNextChar(hDlg, &netm);
			break;
		}
		break;
	}
    return FALSE;
}

// Message handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG:
		return TRUE;
		
	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
		{
			EndDialog(hDlg, LOWORD(wParam));
			return TRUE;
		}
		break;
	}
    return FALSE;
}

HFONT CreateCharacterFont(HDC hDC)
{
	return CreateSongTiFont(hDC, 36);
}

HFONT CreateSongTiFont(HDC hDC, int s)
{
	return CreateFont(
		-MulDiv(s, GetDeviceCaps(hDC, LOGPIXELSY), 72),
		0,
		0,
		0,
		FW_DONTCARE,
		FALSE,
		FALSE,
		FALSE,
		DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_DONTCARE,
		_T("SimSun")
		);
}

HFONT CreateShellDialogFont(HDC hDC, int s)
{
	return CreateFont(
		-MulDiv(s, GetDeviceCaps(hDC, LOGPIXELSY), 72),
		0,
		0,
		0,
		FW_DONTCARE,
		FALSE,
		FALSE,
		FALSE,
		DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_DONTCARE,
		_T("MS Shell Dlg")
		);
}

HFONT GetOldFont(HDC hDC, HFONT f)
{
	if (f == NULL)
	{
		abort();
	}
	HFONT o;
	o = (HFONT)SelectObject(hDC, f);
	SelectObject(hDC, o);
	return o;
}

void PreserveCharacterSpace(HDC hDC, HFONT f, int *py)
{
	TEXTMETRIC tm; // text metrics
	HFONT o; // old font
	const int l = 2; // leading
	// Set to the new font
	o = (HFONT)SelectObject(hDC, f);
	// Get aspects of the new font
	GetTextMetrics(hDC, &tm);
	// NOTE: *py is zero here.
	*py = tm.tmHeight + tm.tmExternalLeading + l;
	// Set to the old font
	SelectObject(hDC, o);
}

HWND CreateEditControl(HWND hWnd, HDC hDC, HFONT f, int *py)
{
	int h;
	int w;
	const int l = 2; // leading
	HWND e; // handle to the edit control
	TEXTMETRIC tm; // text metrics
	HFONT o; // old font
	// Get aspects of the font
	o = (HFONT)SelectObject(hDC, exerFont);
	GetTextMetrics(hDC, &tm);
	SelectObject(hDC, o);
	w = tm.tmMaxCharWidth * 4 + l;
	h = tm.tmHeight + tm.tmExternalLeading + l;
	// Create the edit window
	e = CreateWindow(
		_T("edit"),
		_T(""),
		WS_CHILD | WS_VISIBLE | WS_BORDER | WS_TABSTOP | ES_AUTOHSCROLL,
		PointToPixel(hDC, 6),
		*py,
		w,
		h,
		hWnd,
		(HMENU)IDC_TEXT,
		hInst,
		NULL
		);
	// Set the font
	PostMessage(e, WM_SETFONT, (WPARAM)exerFont, (LPARAM)TRUE);
	*py = *py + h + l;
	return e;
}

HWND CreateButtonControl(HWND hWnd, HDC hDC, int *py)
{
	int h;
	int w;
	const int l = 2; // leading
	HWND b; // handle to the edit control
	TEXTMETRIC tm; // text metrics
	SIZE s; // size
	// Get aspects of the font
	GetTextMetrics(hDC, &tm);
	GetTextExtentPoint(hDC, _T("ȷ"), 6, &s);
	w = s.cx + 4 * l;
	h = tm.tmHeight + tm.tmExternalLeading + 4 * l;
	b = CreateWindow(
		_T("button"),
		_T("ȷ"),
		WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON,
		0,
		*py,
		w,
		h,
		hWnd,
		(HMENU)IDC_OK,
		hInst,
		NULL
		);
	*py = *py + h + l;
	return b;
}

int PointToPixel(HDC hDC, int p)
{
	return MulDiv(p, GetDeviceCaps(hDC, LOGPIXELSY), 72);
}

HFONT CreateExerciseFont(HDC hDC)
{
	// return CreateSongTiFont(hDC, 9);
	return CreateShellDialogFont(hDC, 9);
}

void LoadExerciseFile(HWND hWnd)
{
	OPENFILENAME ofn;
	TCHAR fn[_MAX_PATH] = _T("");
	TCHAR b[80]; // buffer
	FILE *fp; // file pointer
	WUBIITEM ib; // item buffer
	int m; // model

	SetOpenFileName(&ofn, hWnd, fn);
	if (GetOpenFileName(&ofn))
	{
		fp = _tfopen(fn, _T("r"));
		if (fp == NULL)
		{
			MessageBox(hWnd, "ļʱ", "", MB_OK | MB_ICONSTOP);
			return;
		}
		itemList.clear();
		m = 0;
		while (_fgetts(b, sizeof(b), fp) != NULL)
		{
			switch (m)
			{
			case 0:
				CopyFileLine(ib.c, b, sizeof(ib.c));
				break;
			case 1:
				CopyFileLine(ib.co, b, sizeof(ib.co));
				break;
			case 2:
				CopyFileLine(ib.e, b, sizeof(ib.e));
				itemList.insert(itemList.end(), ib);
				break;
			}
			m = (m + 1) % 3;
		}
		itemListI = itemList.begin();
		fclose(fp);
	}
}

void SetOpenFileName(LPOPENFILENAME pofn, HWND hWnd, LPTSTR fn)
{
	pofn->lStructSize       = sizeof(OPENFILENAME);
    pofn->hwndOwner         = hWnd;
    pofn->hInstance         = hInst;
    pofn->lpstrFilter       = _T("ıļ\0*.txt\0");
    pofn->lpstrCustomFilter = NULL;
    pofn->nMaxCustFilter    = 0;
    pofn->nFilterIndex      = 0;
    pofn->lpstrFile         = fn;
    pofn->nMaxFile          = _MAX_PATH;
    pofn->lpstrFileTitle    = NULL;
    pofn->nMaxFileTitle     = 0;
    pofn->lpstrInitialDir   = NULL;
    pofn->lpstrTitle        = _T("ļ");
    pofn->nFileOffset       = 0;
    pofn->nFileExtension    = 0;
    pofn->lpstrDefExt       = _T("txt");
    pofn->lCustData         = (LPARAM)0;
	pofn->lpfnHook 		    = NULL;
	pofn->lpTemplateName    = NULL;
    pofn->Flags             = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_LONGNAMES;
}

void CopyFileLine(LPTSTR d, LPCTSTR s, int si)
{
	int l; // length
	_tcsncpy(d, s, si);
	d[si - 1] = _T('\0');
	l = _tcslen(d) - 1;
	if (l >= 0)
	{
		if (d[l] == _T('\n'))
		{
			d[l] = _T('\0');
		}
	}
}

void ConfirmAnswer(HWND hDlg, int *pe)
{
	TCHAR b[20]; // buffer
	BOOL ta; // to advance

	if (CheckAtEnd(TRUE, hDlg))
	{
		return;
	}
	// get
	SendMessage(GetDlgItem(hDlg, IDC_TEXT), WM_GETTEXT, (WPARAM)sizeof(b), (LPARAM)b);
	// compare
	if (_tcsicmp(b, itemListI->co) == 0)
	{
		// tell
		MessageBox(hDlg, _T("شȷ"), _T("شȷ"), MB_OK);
		ta = TRUE;
	}
	else
	{
		// increase
		*pe = (*pe + 1) % 3;
		// test
		if (*pe == 0)
		{
			// tell
			{
				TCHAR a[100]; // answer
				wsprintf(a, _T("ȷǣ%s\r\n%s"), itemListI->co, itemListI->e);
				MessageBox(hDlg, a, _T("ش"), MB_OK);
			}
			ta = TRUE;
		}
		else
		{
			// tell
			MessageBox(hDlg, _T("شȷԡ"), _T("ش"), MB_OK);
			ta = FALSE;
		}
	}
	// clear
	SendMessage(GetDlgItem(hDlg, IDC_TEXT), WM_SETTEXT, (WPARAM)0, (LPARAM)_T(""));
	// test
	if (ta)
	{
		// advance
		GoNextChar(hDlg, pe);
	}
}

void GoNextChar(HWND hDlg, int *pe)
{
	if (!CheckAtEnd(TRUE, hDlg))
	{
		*pe = 0;
		itemListI++;
		if (!CheckAtEnd(TRUE, hDlg))
		{
			// redraw
			InvalidateRect(hDlg, NULL, TRUE);
		}
		else
		{
			itemListI--;
		}
	}
}

void GoPrevChar(HWND hDlg, int *pe)
{
	if (!CheckAtEnd(FALSE, hDlg))
	{
		*pe = 0;
		itemListI--;
		// redraw
		InvalidateRect(hDlg, NULL, TRUE);
	}
}

BOOL CheckAtEnd(BOOL e, HWND hDlg)
{
	if (itemList.empty())
	{
		MessageBox(hDlg, _T("ûҵ֡\r\nʹò˵һЧϰļ"), _T("ֱ"), MB_OK | MB_ICONINFORMATION);
		return TRUE;
	}
	else
	{
		if (e)
		{
			if (itemListI == itemList.end())
			{
				MessageBox(hDlg, _T("Ѿһˡ"), _T("ѵ"), MB_OK | MB_ICONINFORMATION);
				return TRUE;
			}
			else
			{
				return FALSE;
			}
		}
		else
		{
			if (itemListI == itemList.begin())
			{
				MessageBox(hDlg, _T("Ѿһˡ"), _T("ѵǰ"), MB_OK | MB_ICONINFORMATION);
				return TRUE;
			}
			else
			{
				return FALSE;
			}
		}
	}
}

HFONT CreateWelcomeFont(HDC hDC)
{
	return CreateSongTiFont(hDC, 12);
}